#/usr/bin/sh

FILTER=0
while getopts "c:p:f" flag; do
    case "$flag" in
        c) SIGNAL_DIR=$OPTARG;;
        p) PASSWORD=$OPTARG;;
        f) FILTER=1;
    esac
done

if [ -z "${SIGNAL_DIR+x}" ]; then
    echo -e "a signal configuration directory is required. for example:\n"
    echo -e "  $ run.sh -c ~/.config/Signal/\n"
    exit 1
fi

OUTDIR="$(pwd)/output"

# TODO: learn how to use getopts and rewrite this. this is dumb.
if [ -z "${PASSWORD+x}" ]; then
    if [ $FILTER -eq 1 ]; then
        docker run -it -v "$SIGNAL_DIR":/root/.config/Signal -v "$OUTDIR":/output -v "$(pwd)/config":/config sigint -f /config/chat_list.txt
    else
        docker run -it -v "$SIGNAL_DIR":/root/.config/Signal -v "$OUTDIR":/output sigint
    fi
else
    if [ $FILTER -eq 1 ]; then
        docker run -it -v "$SIGNAL_DIR":/root/.config/Signal -v "$OUTDIR":/output -v "$(pwd)/config":/config sigint -f /config/chat_list.txt --password "$PASSWORD"
    else
        docker run -it -v "$SIGNAL_DIR":/root/.config/Signal -v "$OUTDIR":/output sigint --password "$PASSWORD"
    fi
fi
